stock wS_CreateDeceptionMenu()
{
	///////
	new const String:file[]	= "cfg/deception/menu.txt";
	static old_change_time	= -1;
	new new_change_time		= GetFileTime(file, FileTime_LastChange);
	if (new_change_time == -1 || new_change_time == old_change_time)
	{
		if (new_change_time == -1) LogError("GetFileTime error: %s", file);
		return;
	}
	old_change_time = new_change_time;
	///////

	new Handle:kv = CreateKeyValues("menu");
	if (!FileToKeyValues(kv, file) || !KvGotoFirstSubKey(kv, true))
		SetFailState("KeyValues Error: %s", file);

	for (new D_Function:i; i < D_Function; i++)
	{
		g_FunctionFlag[i] = 0;
		strcopy(g_FunctionText[i], D_FUNCTION_TEXT_SIZE, "-");
	}

	decl String:str_function[D_FUNCTION_SIZE], String:str_flags[10], D_Function:D_Func;
	new Handle:trie = wS_CreateFunctionsTrie(), count = 0;
	do
	{
		if (KvGetNum(kv, "enabled") != 1 || !KvGetSectionName(kv, str_function, D_FUNCTION_SIZE) || TrimString(str_function) < 3)
			continue;

		if (!GetTrieValue(trie, str_function, D_Func))
		{
			if (strcmp(str_function, "MENU TITLE") == 0)
			{
				KvGetString(kv, "text", g_Title, 65, "Управление Чит Функциями");
				Format(g_Title, 65, "%s\n \n", g_Title);
			}
			else
				LogError("Bad function name '%s' in %s", str_function, file);

			continue;
		}

		KvGetString(kv, "text", g_FunctionText[D_Func], D_FUNCTION_TEXT_SIZE, "-");

		KvGetString(kv, "flag", str_flags, 10, "z");
		if ((g_FunctionFlag[D_Func] = ReadFlagString(str_flags)) < 1) g_FunctionFlag[D_Func] = ADMFLAG_ROOT;

		count++;
	}
	while (KvGotoNextKey(kv, true));

	CloseHandle(trie);
	CloseHandle(kv);

	if (count < 1)
		SetFailState("Error: %s empty..", file);
}

stock Handle:wS_CreateFunctionsTrie()
{
	new Handle:trie		= CreateTrie();
	SetTrieValue(trie, "D_Speed",			D_Speed);
	SetTrieValue(trie, "D_DmgFromEnemy",	D_DmgFromEnemy);
	SetTrieValue(trie, "D_DmgFromFriend",	D_DmgFromFriend);
	SetTrieValue(trie, "D_DmgFromWorld",	D_DmgFromWorld);
	SetTrieValue(trie, "D_AntiFlash",		D_AntiFlash);
	SetTrieValue(trie, "D_UnlimitedGrens",	D_UnlimitedGrens);
	SetTrieValue(trie, "D_UnlimitedAmmo",	D_UnlimitedAmmo);
	SetTrieValue(trie, "D_Respawn",			D_Respawn);
	SetTrieValue(trie, "D_Maskirovka",		D_Maskirovka);
	SetTrieValue(trie, "D_ShakeEnemy",		D_ShakeEnemy);
	SetTrieValue(trie, "D_Bhop",			D_Bhop);
	SetTrieValue(trie, "D_Aim",				D_Aim);
	return trie;
}

public Action:deception_cmd(client, args)
{
	if (0 < client <= MaxClients)
	{
		if (g_MyDeceptionMenu[client] != INVALID_HANDLE) DisplayMenu(g_MyDeceptionMenu[client], client, 0);
		else PrintToChat(client, "\x04У вас нет доступа к этой команде");
	}
	return Plugin_Handled;
}

public g_MyDeceptionMenu_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action != MenuAction_Select)
		return;

	decl String:info[5];
	if (!GetMenuItem(menu, item, info, 5))
	{
		PrintToChat(client, "GetMenuItem error");
		return;
	}

	new num = StringToInt(info);
	new D_Function:D_F = D_Function:num;

	g_FunctionOn[client][D_F] = !g_FunctionOn[client][D_F];

	decl String:text[D_FUNCTION_TEXT_SIZE];
	Format(text, D_FUNCTION_TEXT_SIZE, "%s: %s", g_FunctionText[D_F], g_FunctionOn[client][D_F] ? "ВКЛ" : "ОТКЛ");

	InsertMenuItem(menu, item, info, text);
	RemoveMenuItem(menu, item + 1);

	/////

	if (D_F == D_Respawn)
	{
		if (!IsPlayerAlive(client) && GetClientTeam(client) > 1) CS_RespawnPlayer(client);
		DisplayMenuAtItem(menu, client, GetMenuSelectionPosition(), 0);
		return;
	}

	if (!IsPlayerAlive(client))
	{
		DisplayMenuAtItem(menu, client, GetMenuSelectionPosition(), 0);
		return;
	}

	if (D_F == D_Speed)
	{
		SetEntPropFloat(client, Prop_Data, "m_flLaggedMovementValue", g_FunctionOn[client][D_F] ? GetConVarFloat(deception_speed) : 1.0);
	}
	else if (D_F == D_UnlimitedGrens)
	{
		wS_SetGrens(client, g_FunctionOn[client][D_F]);
	}
	else if (D_F == D_Maskirovka)
	{
		if (g_FunctionOn[client][D_F]) wS_Maskirovka(client, GetClientTeam(client) == 2 ? 3 : 2);
		else wS_Maskirovka(client, GetClientTeam(client));
	}
	else if (D_F == D_UnlimitedAmmo)
	{
		if (g_FunctionOn[client][D_F])
		{
			new weapon = GetEntPropEnt(client, Prop_Data, "m_hActiveWeapon");
			if (weapon > MaxClients
				&& (weapon == GetPlayerWeaponSlot(client, 0) || weapon == GetPlayerWeaponSlot(client, 1))
				&& GetEntProp(weapon, Prop_Data, "m_iClip1") < 1)
			{
				decl String:class[32];
				if (GetEntityClassname(weapon, class, 32))
				{
					if (RemovePlayerItem(client, weapon)) AcceptEntityInput(weapon, "Kill");
					GivePlayerItem(client, class);
				}
			}
		}
	}

	DisplayMenuAtItem(menu, client, GetMenuSelectionPosition(), 0);
}